'３次元流跡線V61の標準ﾓｼﾞｭｰﾙ      ［作成］黒田英夫(2023/03)
Imports System.Drawing.Printing

Module FL3LCom
    '３次元の流跡線作画
    '３次元流れ解析「Flow3DLiq」のデータを利用
    '六面体２次要素または四面体２次要素を使用

    'V46での改良点・・・流跡線の色数を６色から１０色に増加、
    '                   流跡線データの入力画面に色見本を表示、
    '                   流跡線アニメーションを追加
    'V47での改良点・・・流跡線データ入力で自動設定がエラー停止するバグを修正、
    '                   ３次元流れ解析の非粘性解析追加に対応
    'V48での改良点・・・四面体２次要素に対応
    'V49での改良点・・・流跡線の幅を可変化
    'V50での改良点・・・３次元グラフィックスで回転操作等の改善
    'V51での改良点・・・３次元グラフィック図でマウス移動（Shiftキー併用）の説明を追加、
    '                   流跡線図でマウスドラッグ矩形の拡大時の回転位置修正
    'V52での改良点・・・構造図で指定要素１個の作画機能を追加
    'V53での改良点・・・各画面でボタンを読みやすい色に改善
    'V54での改良点・・・３次元グラフィック図で回転操作等の改善
    'V55での改良点・・・Visual Basic 2017に変更
    'V56での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードを標準でUTF-8に変更
    '                   （従来のShift-JISもオプションで可能）
    'V57での改良点・・・流跡線図の回転操作の不具合を修正、
    '                   ３次元グラフィック図で回転操作後の部分拡大の角度を保持
    'V58での改良点・・・データ表画面で表計算ソフトから貼り付け時に次行に0が入るのを防止
    'V59での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V60での改良点・・・四面体要素の廃止
    'V61での改良点・・・フリーソフト化、VB2022に移行、文字コードはUTF-8のみ採用

    Public Const Pai As Single = 3.141593  'π

    Public Cr$                      'CR+LFのコード
    Public DirOpen$                 '立ち上げ時のディレクトリー名
    Public Fm$                      '入力データのファイル名
    Public Fstruct$                 '構造データファイル名
    Public Fy$                      '計算結果のファイル名
    Public Title$                   'タイトル

    Public Timst As Date            '計算開始時刻

    Public IncVisc As Integer       '粘性の有無（0:なし、1:有り）
    Public InOut As Integer         'ファイル入出力の種類（0:入力、1:出力）
    Public KBodyForce As Integer    '物体力の有無（0:なし、1:有り）
    Public KcomSide As Integer      '共通辺の表示有無（0:なし、1:有り）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public KdispENum As Integer     '要素番号の表示有無（0:なし、1:有り）
    Public KdispPNum As Integer     '節点番号の表示有無（0:なし、1:有り）
    Public KdispSNum As Integer     '面番号の表示有無（0:なし、1:有り）
    Public KE1 As Integer           '開始要素番号
    Public KE2 As Integer           '最終要素番号
    Public KfileOK As Integer       'ﾌｧｲﾙのOK有無（0:なし、1:有り）
    Public KindElem As Integer      '要素種類（0:六面体20節点、1:四面体10節点）
    '    Public KindEncod As Integer     'ファイルの文字コード（0:UTF-8、1:Shif-JIS）
    Public Kindex As Integer        'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KindFLSet As Integer     '流跡線数の設定区分（0:入力指定、
    '                                1:自動設定・中間節点除外、2:自動設定・中間節点込み）
    Public KindFLSetb As Integer    '上記の保存変数
    Public KindPost As Integer      '後処理の種別（0:流跡線図、1:流跡線アニメーション）
    Public KindTherm As Integer     '温度変化の種別（0:等温、1:非等温）
    Public KmouseDchange As Integer 'ﾏｳｽ指定要素のﾃﾞｰﾀ変更有無
    Public KmouseElem As Integer    'ﾏｳｽ指定の要素番号
    Public KmouseSurf As Integer    'ﾏｳｽ指定の面番号
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public KnumDisp As Integer      '構造作画での番号表示（0:なし、1:有り）
    Public KnumSb As Integer        'ﾌｫﾝﾄ文字ｻｲｽﾞの操作変数
    Public KnumSize As Integer      '構造作画での番号ｻｲｽﾞ
    Public KrearTreat As Integer    '隠面処理の有無（0:なし、1:有り）
    Public Kscreen As Integer       '作画画面サイズ（0：全画面、1：通常画面）
    Public Ktime As Integer         '出力メッシュ番号
    Public Kvisc As Integer         '粘度式の種類（0:なし、1:べき乗、
    '                                2:常用対数、3:自然対数）
    Public MeshStd As Integer       '軸方向長さの基準分割数
    Public Mstat As Integer         '解析種別（０:定常、１:非定常）
    Public Nall As Integer          '変数の総数
    Public NboundP As Integer       '速度・圧力固定の節点数
    Public NboundS As Integer       '速度・圧力固定の面数
    Public NBtempP As Integer       '温度固定の節点数
    Public NBtempS As Integer       '温度固定の面数
    Public Ndim As Integer          '１節点当りの変数の数(=3、温度を除く)
    Public Nelem As Integer         '要素数
    Public Nflux As Integer         '熱流束境界の面の数
    Public Nflow, Nflowb As Integer         '流跡線の数
    Public Ngaus As Integer         'ガウス積分点数(=3)
    Public Npoint As Integer        '節点数
    Public NSdraw As Integer        '作画面の数（隠面処理時）
    Public Nskip As Integer         '節点の飛ばし数
    Public Ntime As Integer         '非定常の出力時間メッシュ数

    Public Cfix As Single           'XY方向ﾋﾟｸｾﾙ差の補正係数
    Public CInc As Single              '最適化計算の増倍率（通常2～3）
    Public CRed As Single              '最適化計算の低減率（通常0.5～0.1）
    Public Ctherm As Single         '比熱
    Public DistFactor As Single     '視点とモデルとの距離倍率（標準1）
    Public EpsL As Single           '要素領域の許容誤差
    Public EyeAngle As Single       '視点と原点を結ぶ線の水平面との角度
    Public Eyeh As Single           '視点高さ
    Public HFactor As Single        '視点の高さ倍率（基準1）
    Public Rlenmax As Single        'ﾓﾃﾞﾙの1軸の最大長さ
    Public Rlenmodel As Single      '視点の距離（座標系間）
    Public TimeMax As Single        '非定常の打切り時間
    Public XaxisMax As Single       'Ｘ軸の最大値
    Public XaxisMin As Single       'Ｘ軸の最小値
    Public Xlower As Single         '作画領域のX最小値
    Public XRotate As Single        'モデルのX軸回りの回転角（右ねじ正、°）
    Public Xupper As Single         '作画領域のX最大値
    Public XYscale As Single        '作画スケール
    Public YaxisMax As Single       'Ｙ軸の最大値
    Public YaxisMin As Single       'Ｙ軸の最小値
    Public Ylower As Single         '作画領域のY最小値
    Public YRotate As Single        'モデルのY軸回りの回転角（右ねじ正、°）
    Public Yupper As Single         '作画領域のY最大値
    Public ZRotate As Single        'モデルのZ軸回りの回転角（右ねじ正、°）

    Public ArrText As New ArrayList()

    Public UFileA(6) As String      '最近使用した入力ﾌｧｲﾙの保存配列

    Public JfixP(,) As Integer      '節点の速度・圧力固定の有無(0:固定なし、1または-1:固定有り)
    Public JfixS(,) As Integer      '面の速度・圧力固定の有無(0:固定なし、1:固定有り)
    Public KdrawElem() As Integer   '各要素の作画有無（0:なし、1:有り）
    Public KE3DCut(2) As Integer    '構造図の面切断の指定（座標軸番号と正負選択）
    Public KEorder() As Integer     '作画順の要素番号
    Public KFcolor() As Integer     '各流跡線の色番号
    Public KinnerLine() As Integer  '内部辺の指定（0:なし、1:有り）
    Public KSelem(,) As Integer     '各要素面の隠面指定（0:なし、1：有り、-1:視線外）
    Public KSorder() As Integer     '作画順の要素の面番号
    Public KsurfFlux(,) As Integer  '流束境界指定の要素・面番号
    Public KsurfPoint(8) As Integer '面の8節点の節点順位
    Public KsurfRest(,) As Integer  '速度・圧力固定の要素・面番号
    Public NNelem(,) As Integer     '各要素における全節点番号
    Public NPrefer() As Integer     '要素計算における節点変数の対応番号
    Public NPstart() As Integer     '流跡線の始点の節点番号
    Public NrestP() As Integer      '速度・圧力固定の節点番号

    Public Accel(3) As Single       '物体力の加速度
    Public Avisc(5) As Single       '粘度式の係数
    Public AxisMax(3) As Single     'モデルのXYZ各軸の最大値
    Public AxisMin(3) As Single     'モデルのXYZ各軸の最小値
    Public CenterPos(3) As Single   '構造中心の座標
    Public Dratio(3) As Single      '最適化計算の変数変化ΔＸの比率（＝ΔＸ／Ｘ）
    Public EpsX(3) As Single        '最適化計算の変数Ｘの最小変化量（絶対値）
    Public Pnorm() As Single        '垂直流束
    Public Shape(20) As Single      '要素の形状関数
    Public Tfp() As Single          'FEM計算の解
    Public TransMat(4, 4) As Single 'モデルの合成アフィン変換行列
    Public VE3DCut(2) As Single     '構造図の面切断の座標値と許容誤差
    Public VfixP(,) As Single       '節点の速度・圧力の固定値
    Public VfixS(,) As Single       '面の速度・圧力の固定値
    Public Xdata(), Ydata(), Zdata() As Single    '節点座標
    Public Xdraw(8), Ydraw(8) As Single   '色塗り多角形の座標
    Public XE(20), YE(20), ZE(20) As Single   '要素計算の配列
    Public Xmodel(), Ymodel(), Zmodel() As Single 'モデル座標における節点座標
    Public Xmouse(), Ymouse() As Single 'ﾏｳｽ位置座標
    Public Xscreen(), Yscreen() As Single     'スクリーンにおける節点座標
    Public Xstart(), Ystart(), Zstart() As Single '流跡線の始点座標
    Public Xvar(3) As Single           '最適化計算の各変数Ｘ（要素内座標ξ、η、ζ）
    Public Xview(), Yview(), Zview() As Single    '視点座標における節点座標（左手系）

    Sub AxisCheck(ByVal k1 As Integer, ByVal k2 As Integer, _
ByRef rlenmax As Single)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        'k1,k2･･･要素の開始、終了番号
        'rlenmax･･･1軸の最大長さ
        Dim ie, ii, ik, j, k, nmax As Integer
        Dim b1 As Single
        If KindElem = 0 Then
            nmax = 20
        End If
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To nmax
                    k = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        AxisMin(1) = Xdata(k)
                        AxisMin(2) = Ydata(k)
                        AxisMin(3) = Zdata(k)
                        For ii = 1 To 3
                            AxisMax(ii) = AxisMin(ii)
                        Next ii
                    Else
                        For ii = 1 To 3
                            Select Case ii
                                Case 1
                                    b1 = Xdata(k)
                                Case 2
                                    b1 = Ydata(k)
                                Case 3
                                    b1 = Zdata(k)
                            End Select
                            If b1 < AxisMin(ii) Then
                                AxisMin(ii) = b1
                            ElseIf b1 > AxisMax(ii) Then
                                AxisMax(ii) = b1
                            End If
                        Next ii
                    End If
                Next j
            End If
        Next ie

        rlenmax = AxisMax(1) - AxisMin(1)
        For ii = 2 To 3
            b1 = AxisMax(ii) - AxisMin(ii)
            If b1 > rlenmax Then
                rlenmax = b1
            End If
        Next ii

    End Sub

    Sub AxisCheck2(ByVal k1 As Integer, ByVal k2 As Integer, _
    ByRef xmin As Single, ByRef xmax As Single, _
    ByRef ymin As Single, ByRef ymax As Single)
        'ｽｸﾘｰﾝにおけるX、Y軸の最小・最大値のﾁｪｯｸ
        'k1,k2･･･要素の開始、終了番号
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim ie, ik, k, j, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To nmax
                    k = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        xmin = Xscreen(k) : xmax = xmin
                        ymin = Yscreen(k) : ymax = ymin
                    Else
                        If Xscreen(k) < xmin Then
                            xmin = Xscreen(k)
                        ElseIf Xscreen(k) > xmax Then
                            xmax = Xscreen(k)
                        End If
                        If Yscreen(k) < ymin Then
                            ymin = Yscreen(k)
                        ElseIf Yscreen(k) > ymax Then
                            ymax = Yscreen(k)
                        End If
                    End If
                Next j
            End If
        Next ie

    End Sub

    Sub AxisCheckM(ByVal k1 As Integer, ByVal k2 As Integer, _
    ByRef rlenmax As Single, ByRef axmax() As Single, ByRef axmin() As Single)
        'ﾓﾃﾞﾙ座標のX、Y、Z軸の最小・最大値のﾁｪｯｸ
        'k1,k2･･･要素の開始、終了番号
        'rlenmax･･･1軸の最大長さ
        'axmax()･･･X,Y,Z座標の最大値
        'axmin()･･･X,Y,Z座標の最小値
        Dim ie, ii, ik, j, k, nmax As Integer
        Dim b1 As Single

        If KindElem = 0 Then
            nmax = 20
        End If
        ik = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To nmax
                    k = NNelem(ie, j)
                    If ik = 0 Then
                        ik = 1
                        axmin(1) = Xmodel(k)
                        axmin(2) = Ymodel(k)
                        axmin(3) = Zmodel(k)
                        For ii = 1 To 3
                            axmax(ii) = axmin(ii)
                        Next ii
                    Else
                        For ii = 1 To 3
                            Select Case ii
                                Case 1
                                    b1 = Xmodel(k)
                                Case 2
                                    b1 = Ymodel(k)
                                Case 3
                                    b1 = Zmodel(k)
                            End Select
                            If b1 < axmin(ii) Then
                                axmin(ii) = b1
                            ElseIf b1 > axmax(ii) Then
                                axmax(ii) = b1
                            End If
                        Next ii
                    End If
                Next j
            End If
        Next ie

        rlenmax = axmax(1) - axmin(1)
        For ii = 2 To 3
            b1 = axmax(ii) - axmin(ii)
            If b1 > rlenmax Then
                rlenmax = b1
            End If
        Next ii

    End Sub

    Sub CalFunc(ByRef sf As Single, ByVal s As Single, _
        ByVal t As Single, ByVal u As Single, ByVal xc As Single, _
        ByVal yc As Single, ByVal zc As Single)
        '任意の関数式を定義して、その関数値を計算する。
        'sf･･･関数値
        's,t,u･･･要素の局所座標
        'xc,yc,zc･･･現在位置の座標
        Dim i, nmax As Integer
        Dim b1, b2, b3, xbb, ybb, zbb As Single
        If KindElem = 0 Then
            nmax = 20
            Call ShapeFuncS(s, t, u)  '形状関数の計算
        End If
        xbb = 0
        ybb = 0
        zbb = 0
        For i = 1 To nmax
            xbb = xbb + Shape(i) * XE(i)
            ybb = ybb + Shape(i) * YE(i)
            zbb = zbb + Shape(i) * ZE(i)
        Next i
        b1 = xbb - xc
        b2 = ybb - yc
        b3 = zbb - zc
        sf = b1 * b1 + b2 * b2 + b3 * b3

    End Sub

    Sub CfileIn1U(ByVal fxx$)
        '計算結果ﾌｧｲﾙを読込み、等温・非等温の確認
        'UTF-8･･･BOMなし
        'fxx$･･･計算結果ﾌｧｲﾙ名
        Dim aa$

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Mstat = dat(1)
        If Mstat > 0 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            TimeMax = dat(1)
            Ntime = dat(3)
        End If
        Do
            aa$ = sr.ReadLine
            If aa$ = "等温流" Then
                KindTherm = 0
                Exit Do
            ElseIf aa$ = "非等温流" Then
                KindTherm = 1
                Exit Do
            End If
        Loop

        sr.Close()

    End Sub

    Sub CoordiChange(ByVal rlenb As Single)
        '節点座標の視点座標への変換
        'rlenb･･･ﾓﾃﾞﾙ座標原点と視点座標との距離
        Dim ip As Integer
        For ip = 1 To Npoint
            Xview(ip) = Xmodel(ip)
            Yview(ip) = Zmodel(ip)
            Zview(ip) = Ymodel(ip) + rlenb
        Next ip

    End Sub

    Private Sub CrosPoint(ByRef alphab As Single, ByRef beta As Single, _
    ByVal eps As Single, ByVal xbuf() As Single, ByVal ybuf() As Single, _
    ByVal xbufc() As Single, ByVal ybufc() As Single)
        '2線分の交点計算
        'alphab,beta･･･各線分の交点位置比
        'xbuf(),ybuf()･･･基準側の2節点座標
        'xbufc(),ybufc()･･･比較側の2節点座標
        Dim a1, a2, b1, b2, b3, b4, bb, cc, dd, dist, distb As Single
        Dim eps2, f1, f2, xb, yb As Single

        alphab = -1
        eps2 = eps * eps
        a1 = ybuf(2) - ybuf(1)
        b1 = -(xbuf(2) - xbuf(1))
        dist = Math.Sqrt(a1 * a1 + b1 * b1)
        a2 = ybufc(2) - ybufc(1)
        b2 = -(xbufc(2) - xbufc(1))
        distb = Math.Sqrt(a2 * a2 + b2 * b2)
        If dist < eps Or distb < eps Then
            Exit Sub
        End If
        If Math.Abs(a1) < eps And Math.Abs(b2) < eps Then
            xb = xbufc(1)
            yb = ybuf(1)
            b1 = xb - xbuf(1)
            b2 = yb - ybufc(1)
            cc = b1 * (xb - xbuf(2))
            dd = b2 * (yb - ybufc(2))
            If cc < eps2 And dd < eps2 Then
                alphab = Math.Abs(b1) / dist
                beta = Math.Abs(b2) / distb
            End If
        ElseIf Math.Abs(b1) < eps And Math.Abs(a2) < eps Then
            xb = xbuf(1)
            yb = ybufc(1)
            b1 = yb - ybuf(1)
            b2 = xb - xbufc(1)
            cc = b1 * (yb - ybuf(2))
            dd = b2 * (xb - xbufc(2))
            If cc < eps2 And dd < eps2 Then
                alphab = Math.Abs(b1) / dist
                beta = Math.Abs(b2) / distb
            End If
        Else
            f1 = a1 * xbuf(1) + b1 * ybuf(1)
            f2 = a2 * xbufc(1) + b2 * ybufc(1)
            bb = a1 * b2 - b1 * a2
            If Math.Abs(bb) > eps2 Then
                xb = (f1 * b2 - f2 * b1) / bb
                yb = (f2 * a1 - f1 * a2) / bb
                b1 = xb - xbuf(1)
                b2 = yb - ybuf(1)
                cc = b1 * (xb - xbuf(2))
                dd = b2 * (yb - ybuf(2))
                If cc < eps2 And dd < eps2 Then
                    b3 = xb - xbufc(1)
                    b4 = yb - ybufc(1)
                    cc = b3 * (xb - xbufc(2))
                    dd = b4 * (yb - ybufc(2))
                    If cc < eps2 And dd < eps2 Then
                        alphab = Math.Sqrt(b1 * b1 + b2 * b2) / dist
                        beta = Math.Sqrt(b3 * b3 + b4 * b4) / distb
                    End If
                End If
            End If
        End If

    End Sub

    Sub DfileInput2U(ByVal fxx$)
        '構造ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$
        Dim i, j, jb, nmax As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "Flow3DLiq" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KindElem = dat(1)
        Title$ = sr.ReadLine
        If KindElem = 0 Then
            nmax = 20
        Else
            aa$ = "六面体要素以外は使用できません！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        IncVisc = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nelem = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        NboundP = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        NboundS = dat(1)
        If IncVisc = 1 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NBtempP = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NBtempS = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Nflux = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Kvisc = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KBodyForce = dat(1)
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Ngaus = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Ndim = dat(1)
        Else
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Nflux = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KBodyForce = dat(1)
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Ngaus = dat(1)
        End If

        ReDim NNelem(Nelem, nmax)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)
        ReDim NrestP(NboundP), JfixP(NboundP, 4), VfixP(NboundP, 4)
        ReDim KsurfRest(NboundS, 2), JfixS(NboundS, 4), VfixS(NboundS, 4)
        ReDim KsurfFlux(Nflux, 2), Pnorm(Nflux)

        aa$ = sr.ReadLine
        For i = 1 To Nelem
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            For j = 1 To 10
                NNelem(i, j) = dat(j)
            Next j
            If nmax > 10 Then
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 11 To nmax
                    NNelem(i, j) = dat(j - 11)
                Next j
            End If
        Next i

        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Xdata(i) = dat(1)
            Ydata(i) = dat(2)
            Zdata(i) = dat(3)
        Next i
        If NboundP > 0 Then
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            For i = 1 To NboundP
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                NrestP(i) = dat(1)
                If IncVisc = 0 Then
                    VfixP(i, 1) = dat(2)
                Else
                    For j = 1 To Ndim
                        jb = 2 * j
                        JfixP(i, j) = dat(jb)
                        VfixP(i, j) = dat(jb + 1)
                    Next j
                End If
            Next i
        End If

        If NboundS > 0 Then
            aa$ = sr.ReadLine
            aa$ = sr.ReadLine
            For i = 1 To NboundS
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KsurfRest(i, 1) = dat(1)
                KsurfRest(i, 2) = dat(2)
                If IncVisc = 0 Then
                    VfixS(i, 1) = dat(3)
                Else
                    For j = 1 To Ndim
                        jb = 2 * j
                        JfixS(i, j) = dat(jb + 1)
                        VfixS(i, j) = dat(jb + 2)
                    Next j
                End If
            Next i
        End If

        If IncVisc = 1 Then
            If NBtempP > 0 Then
                aa$ = sr.ReadLine
                For i = 1 To NBtempP
                    aa$ = sr.ReadLine
                Next i
            End If

            If NBtempS > 0 Then
                aa$ = sr.ReadLine
                For i = 1 To NBtempS
                    aa$ = sr.ReadLine
                Next i
            End If
        End If

        If Nflux > 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nflux
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                KsurfFlux(i, 1) = dat(1)
                KsurfFlux(i, 2) = dat(2)
                Pnorm(i) = dat(3)
            Next i
        End If

        sr.Close()

    End Sub

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        Dim aa$, titleb$
        Dim i As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "Flow3DLine" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Fstruct$ = dat(1)

        titleb$ = Title$
        Try
            Call DfileInput2U(Fstruct$)
        Catch ex As Exception
            aa$ = "構造ファイルを読み込めません！"
            MsgBox(aa$, 0, "データエラー")
            Exit Sub
        End Try
        If titleb$ <> "" Then
            Title$ = titleb$
        End If

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Fy$ = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nflow = dat(1)

        ReDim KFcolor(Nflow), NPstart(Nflow)
        ReDim Xstart(Nflow), Ystart(Nflow), Zstart(Nflow)
        aa$ = sr.ReadLine

        For i = 1 To Nflow
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            KFcolor(i) = dat(1)
            NPstart(i) = dat(2)
            Xstart(i) = dat(3)
            Ystart(i) = dat(4)
            Zstart(i) = dat(5)
        Next i

        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i As Integer

        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "プログラム名" + "," + "Flow3DLine"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "［構造データファイル］" + "," + Fstruct$
        sw.WriteLine(aa$)
        aa$ = "［解析結果ファイル］" + "," + Fy$
        sw.WriteLine(aa$)
        aa$ = "流跡線数" + "," + Str(Nflow)
        sw.WriteLine(aa$)

        aa$ = "流跡線指定データ（No.、色番号、節点番号、始点Ｘ、始点Ｙ、始点Ｚ）"
        sw.WriteLine(aa$)
        For i = 1 To Nflow
            aa$ = Str$(i) + ",   " + Str$(KFcolor(i))
            aa$ = aa$ + ",   " + Str$(NPstart(i))
            aa$ = aa$ + ",   " + Str$(Xstart(i))
            aa$ = aa$ + ",   " + Str$(Ystart(i))
            aa$ = aa$ + ",   " + Str$(Zstart(i))
            sw.WriteLine(aa$)
        Next i

        sw.Close()

        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Private Sub DistComp(ByRef ic As Integer, ByVal kbuf() As Integer)
        '距離比較
        'ic･･･基準面の距離区分（0:近い、1:遠い）
        'kbuf()･･･比較面の8節点番号
        Dim i, i1, i2, ib, icc, j, j1, j2, jb, nmax As Integer
        Dim alphab, b1, b2, b3, beta, c1, dist, distc, eps, xb, yb, zb As Single
        Dim xbuf(2), xbufc(2), ybuf(2), ybufc(2) As Single

        If KindElem = 0 Then
            nmax = 8
            c1 = 0.25
        End If
        ic = -1  '仮設定
        For i = 1 To nmax - 1 Step 2
            i1 = KsurfPoint(i)
            ib = i + 2
            If ib > nmax Then
                ib = 1
            End If
            i2 = KsurfPoint(ib)
            xbuf(1) = Xscreen(i1)
            ybuf(1) = Yscreen(i1)
            xbuf(2) = Xscreen(i2)
            ybuf(2) = Yscreen(i2)
            b1 = Xmodel(i1) - Xmodel(i2)
            b2 = Ymodel(i1) - Ymodel(i2)
            b3 = Zmodel(i1) - Zmodel(i2)
            eps = 0.0001 * Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
            For j = 1 To nmax - 1 Step 2
                j1 = kbuf(j)
                jb = j + 2
                If jb > nmax Then
                    jb = 1
                End If
                j2 = kbuf(jb)
                icc = 0
                If i1 = j1 Or i1 = j2 Then
                    icc = 1
                ElseIf i2 = j1 Or i2 = j2 Then
                    icc = 1
                End If
                If icc = 0 Then
                    xbufc(1) = Xscreen(j1)
                    ybufc(1) = Yscreen(j1)
                    xbufc(2) = Xscreen(j2)
                    ybufc(2) = Yscreen(j2)
                    Call CrosPoint(alphab, beta, eps, xbuf, ybuf, xbufc, ybufc)
                    '2線分の交点計算

                    If alphab >= 0 Then
                        b1 = 1 - alphab
                        xb = b1 * Xmodel(i1) + alphab * Xmodel(i2)
                        yb = b1 * Ymodel(i1) + alphab * Ymodel(i2) + Rlenmodel
                        zb = b1 * Zmodel(i1) + alphab * Zmodel(i2) - Eyeh
                        dist = xb * xb + yb * yb + zb * zb
                        b1 = 1 - beta
                        xb = b1 * Xmodel(j1) + beta * Xmodel(j2)
                        yb = b1 * Ymodel(j1) + beta * Ymodel(j2) + Rlenmodel
                        zb = b1 * Zmodel(j1) + beta * Zmodel(j2) - Eyeh
                        distc = xb * xb + yb * yb + zb * zb
                        If dist < distc Then
                            ic = 0
                        Else
                            ic = 1
                        End If
                        icc = -1
                        Exit For
                    End If
                End If
            Next j
            If icc < 0 Then
                Exit For
            End If
        Next i

        If ic < 0 Then
            xb = 0 : yb = 0 : zb = 0
            For i = 1 To nmax - 1 Step 2
                ib = KsurfPoint(i)
                xb = xb + Xmodel(ib)
                yb = yb + Ymodel(ib)
                zb = zb + Zmodel(ib)
            Next
            xb = c1 * xb
            yb = c1 * yb + Rlenmodel
            zb = c1 * zb - Eyeh
            dist = xb * xb + yb * yb + zb * zb
            xb = 0 : yb = 0 : zb = 0
            For i = 1 To nmax - 1 Step 2
                ib = kbuf(i)
                xb = xb + Xmodel(ib)
                yb = yb + Ymodel(ib)
                zb = zb + Zmodel(ib)
            Next
            xb = c1 * xb
            yb = c1 * yb + Rlenmodel
            zb = c1 * zb - Eyeh
            distc = xb * xb + yb * yb + zb * zb

            If dist < distc Then
                ic = 0
            Else
                ic = 1
            End If
        End If

    End Sub

    Sub DrawFocusRect(ByRef gr As Graphics)
        'ﾌｫｰｶｽ矩形の描画
        Dim rect As Rectangle
        Dim p1, p2 As Point

        If Xmouse(1) <= Xmouse(2) Then
            p1.X = Xmouse(1)
            p2.X = Xmouse(2)
        Else
            p1.X = Xmouse(2)
            p2.X = Xmouse(1)
        End If
        If Ymouse(1) <= Ymouse(2) Then
            p1.Y = Ymouse(1)
            p2.Y = Ymouse(2)
        Else
            p1.Y = Ymouse(2)
            p2.Y = Ymouse(1)
        End If
        rect.X = p1.X
        rect.Y = p1.Y
        rect.Width = p2.X - p1.X
        rect.Height = p2.Y - p1.Y

        gr.DrawRectangle(Pens.DarkGray, rect)   '矩形の描画

    End Sub

    Sub DrawScale(ByVal dpixb As Single, ByVal dpiyb As Single, _
    ByVal xlen As Single, ByVal ylen As Single, ByVal xmin As Single, _
    ByVal xmax As Single, ByVal ymin As Single, ByVal ymax As Single)
        '作画倍率の計算
        'dpixb･･･X軸方向のdpi値
        'dpiyb･･･Y軸方向のdpi値
        'xlen･･･作画領域のX方向長さ
        'ylen･･･作画領域のY方向長さ
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim b1, b2, cx, cy As Single

        Cfix = dpiyb / dpixb

        b1 = xmax - xmin : b2 = ymax - ymin
        If Cfix < 1 Then
            If b1 <> 0 Then
                cx = xlen / b1
            End If
            If b2 <> 0 Then
                cy = ylen / b2 / Cfix
            End If
        Else
            If b1 <> 0 Then
                cx = Cfix * xlen / b1
            End If
            If b2 <> 0 Then
                cy = ylen / b2
            End If
        End If
        If b1 = 0 Then
            XYscale = cy
        ElseIf b2 = 0 Then
            XYscale = cx
        ElseIf cy < cx Then
            XYscale = cy
        Else
            XYscale = cx
        End If

    End Sub

    Sub Elem3DPrep()
        '構造図作画準備
        Dim ie As Integer
        ReDim KdrawElem(Nelem)
        ReDim Xmodel(Npoint), Ymodel(Npoint), Zmodel(Npoint)
        ReDim Xscreen(Npoint), Yscreen(Npoint)
        ReDim Xview(Npoint), Yview(Npoint), Zview(Npoint)

        KE1 = 1
        KE2 = Nelem
        For ie = KE1 To KE2
            KdrawElem(ie) = 1
        Next ie

        KrearTreat = 1

        Rlenmax = 0
        DistFactor = 0      '作画ﾊﾟﾗﾒｰﾀｰのｸﾘｱ

    End Sub

    Sub ElemCheck(ByRef ic As Integer, ByVal ie As Integer, _
    ByRef s As Single, ByRef t As Single, ByRef u As Single, _
    ByVal xb As Single, ByVal yb As Single, ByVal zb As Single)
        '要素内点のﾁｪｯｸ
        'ic･･･要素内外の判定（0：外、1：内）
        'ie･･･要素番号
        's,t,u,･･･要素の局所座標
        'xb,yb,zb･･･点の座標
        Dim icc, j, k, kb, nmax As Integer
        Dim buf, cbuf, s0, sfm, xemax, xemin, yemax, yemin, zemax, zemin As Single
        buf = 1.001
        cbuf = -0.001
        If KindElem = 0 Then
            nmax = 20
        End If
        ic = 0
        For j = 1 To nmax
            kb = NNelem(ie, j)
            XE(j) = Xdata(kb)
            YE(j) = Ydata(kb)
            ZE(j) = Zdata(kb)
            If j = 1 Then
                xemin = XE(1)
                xemax = xemin
                yemin = YE(1)
                yemax = yemin
                zemin = ZE(1)
                zemax = zemin
            Else
                If XE(j) < xemin Then
                    xemin = XE(j)
                ElseIf XE(j) > xemax Then
                    xemax = XE(j)
                End If
                If YE(j) < yemin Then
                    yemin = YE(j)
                ElseIf YE(j) > yemax Then
                    yemax = YE(j)
                End If
                If ZE(j) < zemin Then
                    zemin = ZE(j)
                ElseIf ZE(j) > zemax Then
                    zemax = ZE(j)
                End If
            End If
        Next j
        icc = 0
        If xb < xemin - EpsL Then
            icc = 1
        ElseIf xb > xemax + EpsL Then
            icc = 1
        End If
        If icc = 0 Then
            If yb < yemin - EpsL Then
                icc = 1
            ElseIf yb > yemax + EpsL Then
                icc = 1
            End If
        End If
        If icc = 0 Then
            If zb < zemin - EpsL Then
                icc = 1
            ElseIf zb > zemax + EpsL Then
                icc = 1
            End If
        End If
        If icc = 0 Then
            s = 0.2 : t = 0.2 : u = 0.2
            Call KHSolver(k, 100, s0, sfm, s, t, u, xb, yb, zb)
            'KH法による最適化ｿﾙﾊﾞｰ
            If KindElem = 0 Then
                If s > -buf And s < buf Then
                    If t > -buf And t < buf Then
                        If u > -buf And u < buf Then
                            ic = 1
                        End If
                    End If
                End If
            End If
        End If

    End Sub

    Sub ElemRelation(ByRef icc As Integer, ByVal ie As Integer, ByVal ib As Integer)
        '要素関係の判別
        'icc･･･関係の有無（0:なし、1:有り）
        'ie･･･元の要素番号
        'ib･･･対象の要素番号
        Dim i, j, k As Integer
        If KindElem = 0 Then
            For i = 1 To 7 Step 2
                k = NNelem(ie, i)
                For j = 1 To 7 Step 2
                    If k = NNelem(ib, j) Then
                        icc = 1
                        Exit Sub
                    End If
                Next j
                For j = 13 To 19 Step 2
                    If k = NNelem(ib, j) Then
                        icc = 1
                        Exit Sub
                    End If
                Next j
            Next i
            For i = 13 To 19 Step 2
                k = NNelem(ie, i)
                For j = 1 To 7 Step 2
                    If k = NNelem(ib, j) Then
                        icc = 1
                        Exit Sub
                    End If
                Next j
                For j = 13 To 19 Step 2
                    If k = NNelem(ib, j) Then
                        icc = 1
                        Exit Sub
                    End If
                Next j
            Next i
        End If

    End Sub

    Sub ElemSearch(ByRef k1 As Integer, ByRef k2 As Integer)
        '拡大作画する要素の探索
        '全節点が指定領域にある要素を採用、作画要素なしの場合は元のﾃﾞｰﾀを保存
        'k1,k2･･･要素の開始、終了番号
        Dim ic, ie, j, k, kmin, kmax, nmax As Integer
        Dim b1, b2 As Single
        Dim kbuf(Nelem) As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        ic = 0
        For ie = 1 To Nelem
            kbuf(ie) = KdrawElem(ie)
            If KdrawElem(ie) > 0 Then
                For j = 1 To nmax
                    k = NNelem(ie, j)
                    b1 = Xscreen(k) - Xmouse(1)
                    b2 = Xscreen(k) - Xmouse(2)
                    If b1 >= 0 And b2 <= 0 Then
                        b1 = Yscreen(k) - Ymouse(2)
                        b2 = Yscreen(k) - Ymouse(1)
                        If b1 >= 0 And b2 <= 0 Then
                            If j = nmax Then
                                KdrawElem(ie) = 1
                                If ic = 0 Then
                                    ic = 1
                                    kmin = ie
                                    kmax = ie
                                ElseIf ie < kmin Then
                                    kmin = ie
                                ElseIf ie > kmax Then
                                    kmax = ie
                                End If
                            End If
                        Else
                            KdrawElem(ie) = 0
                            Exit For
                        End If
                    Else
                        KdrawElem(ie) = 0
                        Exit For
                    End If
                Next j
            End If
        Next ie
        k1 = kmin
        k2 = kmax
        If k1 = 0 Then
            For ie = 1 To Nelem
                KdrawElem(ie) = kbuf(ie)
            Next ie
        End If

    End Sub

    Sub EyeCheck(ByVal k1 As Integer, ByVal k2 As Integer)
        '視線ﾁｪｯｸ（面の中心位置で判定）
        'k1,k2･･･開始・終了要素番号
        Dim ie, j, k, kb, kmax, nb, nmax As Integer
        Dim b1, b2, b3, b4, xb, yb, zb As Single
        Dim eyevec(3), planevec(3) As Single
        Dim xbufb(3), ybufb(3), zbuf(3) As Single

        If KindElem = 0 Then
            kmax = 6
            nmax = 8
            nb = 4
        End If
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For k = 1 To kmax
                    If KSelem(ie, k) = 0 Then
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, k, KsurfPoint)  '面の設定
                        End If

                        xb = 0 : yb = 0 : zb = 0
                        For j = 2 To nmax Step 2
                            kb = KsurfPoint(j)
                            xb = xb + Xmodel(kb)
                            yb = yb + Ymodel(kb)
                            zb = zb + Zmodel(kb) - Eyeh
                            Select Case j
                                Case 2
                                    xbufb(2) = Xmodel(kb)
                                    ybufb(2) = Ymodel(kb)
                                    zbuf(2) = Zmodel(kb) - Eyeh
                                Case 4
                                    xbufb(3) = Xmodel(kb)
                                    ybufb(3) = Ymodel(kb)
                                    zbuf(3) = Zmodel(kb) - Eyeh
                            End Select
                        Next j
                        xbufb(1) = xb / nb
                        ybufb(1) = yb / nb
                        zbuf(1) = zb / nb

                        '逆視線ﾍﾞｸﾄﾙの計算
                        b1 = -xbufb(1)
                        b2 = -(Rlenmodel + ybufb(1))
                        b3 = -zbuf(1)
                        b4 = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
                        eyevec(1) = b1 / b4
                        eyevec(2) = b2 / b4
                        eyevec(3) = b3 / b4

                        '面の法線ﾍﾞｸﾄﾙの計算
                        b1 = (ybufb(2) - ybufb(1)) * (zbuf(3) - zbuf(1))
                        b1 = b1 - (zbuf(2) - zbuf(1)) * (ybufb(3) - ybufb(1))
                        b2 = (zbuf(2) - zbuf(1)) * (xbufb(3) - xbufb(1))
                        b2 = b2 - (xbufb(2) - xbufb(1)) * (zbuf(3) - zbuf(1))
                        b3 = (xbufb(2) - xbufb(1)) * (ybufb(3) - ybufb(1))
                        b3 = b3 - (ybufb(2) - ybufb(1)) * (xbufb(3) - xbufb(1))
                        b4 = Math.Sqrt(b1 * b1 + b2 * b2 + b3 * b3)
                        planevec(1) = b1 / b4
                        planevec(2) = b2 / b4
                        planevec(3) = b3 / b4

                        '逆視線ﾍﾞｸﾄﾙと面法線ﾍﾞｸﾄﾙのｽｶﾗｰ積計算
                        b1 = 0
                        For j = 1 To 3
                            b1 = b1 + eyevec(j) * planevec(j)
                        Next j
                        If b1 <= 0 Then
                            KSelem(ie, k) = -1   '視線外
                        End If
                    End If
                Next k
            End If
        Next ie

    End Sub

    Sub FileName(ByVal fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub InnerCheck2(ByVal k1 As Integer, ByVal k2 As Integer)
        '内面ﾁｪｯｸ
        'k1,k2･･･開始・終了要素番号
        Dim ib, ic, icc, ie, ik, ik1, j, jj, jx, k, kk, kmax, ksb, ksmax, m, nmax As Integer
        Dim kbuf(8) As Integer

        If KindElem = 0 Then
            kmax = 6
            ksmax = 4
            nmax = 7
            ReDim KinnerLine(12 * Nelem) '内部辺のﾌﾗｯｸﾞ
        End If
        Dim ksbuf(Nelem, kmax) As Integer    'ﾁｪｯｸ済みﾌﾗｯｸﾞ
        For ie = k1 To k2 - 1
            If KdrawElem(ie) > 0 Then
                For k = 1 To kmax
                    If k = 1 Then
                        icc = 0
                    End If
                    If ksbuf(ie, k) = 0 Then
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, k, KsurfPoint)  '面の設定
                        End If
                        ik = 0
                        For ib = ie + 1 To k2
                            If KdrawElem(ib) > 0 Then
                                If icc = 0 Then
                                    Call ElemRelation(icc, ie, ib)    '要素関係の判別
                                End If
                                If icc > 0 Then
                                    For kk = 1 To kmax
                                        If ksbuf(ib, kk) = 0 Then
                                            If KindElem = 0 Then
                                                Call SurfaceSet(ib, kk, kbuf)   '面の設定
                                            End If

                                            ik1 = KsurfPoint(1)
                                            ic = 0
                                            For j = 1 To nmax Step 2
                                                If ik1 = kbuf(j) Then
                                                    jx = j
                                                    For jj = 3 To nmax Step 2
                                                        jx = jx - 2
                                                        If jx < 1 Then
                                                            jx = nmax
                                                        End If
                                                        If KsurfPoint(jj) <> kbuf(jx) Then
                                                            ic = 1
                                                            Exit For
                                                        End If
                                                    Next jj
                                                    If ic = 0 Then
                                                        ik = 1
                                                        KSelem(ie, k) = 1
                                                        KSelem(ib, kk) = 1
                                                        ksbuf(ie, k) = 1
                                                        ksbuf(ib, kk) = 1
                                                        For m = 1 To ksmax
                                                            ksb = KSideLine(ie, k, m)
                                                            KinnerLine(ksb) = 1
                                                            ksb = KSideLine(ib, kk, m)
                                                            KinnerLine(ksb) = 1
                                                        Next m
                                                    End If
                                                    Exit For
                                                End If
                                            Next j
                                            If ik = 1 Then
                                                Exit For
                                            End If
                                        End If
                                    Next kk
                                    If ik = 1 Then
                                        Exit For
                                    End If
                                End If
                            Else
                                icc = 0
                            End If
                        Next ib
                    End If
                Next k
            End If
        Next ie

    End Sub

    Sub KHSolver(ByRef k As Integer, ByVal kmax As Integer, _
        ByRef s0 As Single, ByRef sfm As Single, ByRef s As Single, _
        ByRef t As Single, ByRef u As Single, ByVal xc As Single, _
        ByVal yc As Single, ByVal zc As Single)
        'KH法による最適化ｿﾙﾊﾞｰ
        'k･･･繰返し数
        'kmax･･･最大繰返し数（計算打切り）
        's0･･･初期の関数値
        'sfm･･･最適化した最終関数値
        's,t,u･･･要素の局所座標
        'xc,yc,zc･･･現在位置の座標
        Dim i, ichange, j, knew, nx As Integer
        Dim b1, b2, dx, sf, xb, xm As Single

        nx = 3              '変数の数
        Xvar(1) = s : Xvar(2) = t : Xvar(3) = u
        For i = 1 To nx
            Dratio(i) = 0.1
            EpsX(i) = 0.0001
        Next i

        Dim xmbuf(nx) As Single   '変数の前回中心値Ｘ
        Dim dxbuf(nx) As Single   '変数の前回変化ΔＸ

        k = 0
        Call CalFunc(s0, s, t, u, xc, yc, zc) '初期の関数値計算
        sfm = s0

        Do
            knew = 0    '変数の中心値Ｘと変化ΔＸの更新有無
            k = k + 1   '繰返し回数加算
            For i = 1 To nx      '各変数毎の計算
                xb = Xvar(i)
                xm = xb
                dx = xb * Dratio(i)
                If Math.Abs(dx) < EpsX(i) Then  'dxが0になるのを防止
                    dx = EpsX(i)
                End If
                If k = 1 Or xm <> xmbuf(i) Or dx <> dxbuf(i) Then
                    knew = 1
                End If
                xmbuf(i) = xm
                dxbuf(i) = dx

                ichange = 0         '各変数での改善有無
                For j = 1 To 2      '変数値の±ΔＸで改善比較
                    If j = 1 Then
                        Xvar(i) = xb - dx
                    Else
                        Xvar(i) = xb + dx
                    End If
                    Call CalFunc(sf, Xvar(1), Xvar(2), Xvar(3), xc, yc, zc)
                    '関数値計算
                    If sf < sfm Then        '最小化
                        '                If sf > sfm Then       '最大化
                        ichange = 1
                        sfm = sf
                        xm = Xvar(i)
                    End If
                Next j
                Xvar(i) = xm
                If ichange > 0 Then     '改善有りの場合はΔＸ比率を増倍
                    Dratio(i) = CInc * Dratio(i)
                Else        '改善なしの場合はΔＸ比率を低減
                    b1 = Dratio(i)
                    Dratio(i) = CRed * b1
                    b2 = Math.Abs(Xvar(i) * Dratio(i))

                    'ΔＸは最小変化量以上とする
                    If b2 < EpsX(i) Then
                        Dratio(i) = b1
                    End If
                End If
            Next i
        Loop While k < kmax And knew = 1
        s = Xvar(1)
        t = Xvar(2)
        u = Xvar(3)

    End Sub

    Function KSideLine(ByVal ib As Integer, ByVal kb As Integer, _
ByVal kk As Integer) As Integer
        '辺番号の照合
        'ib･･･要素番号
        'kb･･･面番号
        'kk･･･面の辺番号
        Dim ksb As Integer

        If KindElem = 0 Then    '六面体
            Select Case kb
                Case 1
                    ksb = kk
                Case 2
                    ksb = 13 - kk
                Case 3
                    Select Case kk
                        Case 1
                            ksb = 5
                        Case 2
                            ksb = 9
                        Case 3
                            ksb = 6
                        Case 4
                            ksb = 1
                    End Select
                Case 4
                    Select Case kk
                        Case 1
                            ksb = 7
                        Case 2
                            ksb = 11
                        Case 3
                            ksb = 8
                        Case 4
                            ksb = 3
                    End Select
                Case 5
                    Select Case kk
                        Case 1
                            ksb = 6
                        Case 2
                            ksb = 10
                        Case 3
                            ksb = 7
                        Case 4
                            ksb = 2
                    End Select
                Case 6
                    Select Case kk
                        Case 1
                            ksb = 8
                        Case 2
                            ksb = 12
                        Case 3
                            ksb = 5
                        Case 4
                            ksb = 4
                    End Select
            End Select
            KSideLine = 12 * (ib - 1) + ksb
        End If

    End Function

    Sub ModelTrans(ByVal nb As Integer, ByRef xbuf() As Single, _
    ByRef ybuf() As Single, ByRef zbuf() As Single)
        'ﾓﾃﾞﾙ節点座標のｱﾌｨﾝ変換
        'nb･･･節点数
        'xbuf(),ybuf(),zbuf()･･･節点のX,Y,Z座標
        Dim ip, j, k As Integer
        Dim b1 As Single
        Dim buf(3) As Single
        For ip = 1 To nb
            buf(1) = xbuf(ip)
            buf(2) = ybuf(ip)
            buf(3) = zbuf(ip)
            For k = 1 To 3
                b1 = 0
                For j = 1 To 3
                    b1 = b1 + TransMat(k, j) * buf(j)
                Next j
                b1 = b1 + TransMat(k, 4)
                Select Case k
                    Case 1
                        xbuf(ip) = b1
                    Case 2
                        ybuf(ip) = b1
                    Case 3
                        zbuf(ip) = b1
                End Select
            Next k
        Next ip

    End Sub

    Sub MouseCalc()
        'ﾏｳｽ点のﾓﾃﾞﾙ座標への変換
        Dim j As Integer
        Dim xa, xb, ya, yb As Single
        For j = 1 To 2
            xa = Xmouse(j)
            ya = Ymouse(j)
            If Cfix < 1 Then
                xb = (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale / Cfix + YaxisMin
            Else
                xb = Cfix * (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale + YaxisMin
            End If
            Xmouse(j) = xb
            Ymouse(j) = yb
        Next j

    End Sub

    Sub NodePointSet()
        '始点の節点番号の設定
        Dim i, ip, j, k, nb, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nflow
            k = 0
            For ip = 1 To Nelem
                For j = 1 To nmax
                    nb = NNelem(ip, j)
                    If Xstart(i) = Xdata(nb) Then
                        If Ystart(i) = Ydata(nb) Then
                            If Zstart(i) = Zdata(nb) Then
                                k = nb
                                Exit For
                            End If
                        End If
                    End If
                Next j
            Next ip
            NPstart(i) = k
        Next i

    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FL3LMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            Kscreen = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\FL3LMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.WriteLine(Kscreen)
        sw.Close()

    End Sub

    Sub OuterReset(ByVal k1 As Integer, ByVal k2 As Integer)
        '外郭面の再設定
        'k1,k2･･･開始・終了要素番号
        Dim ie, k, kmax As Integer
        If KindElem = 0 Then
            kmax = 6
        End If
        For ie = k1 To k2
            For k = 1 To kmax
                If KSelem(ie, k) < 0 Then
                    KSelem(ie, k) = 0
                End If
            Next k
        Next ie
    End Sub

    Sub PaintExe(ByRef gr As Graphics, ByVal ncount As Integer, _
        ByVal colorx As Color, ByVal kind As Integer)
        '塗りつぶし実行
        'gr･･･ｸﾞﾗﾌｨｯｸｽ･ｵﾌﾞｼﾞｪｸﾄ名
        'ncount･･･頂点数
        'colorx･･･境界および塗りつぶしの色
        'kind･･･境界作画の有無（0:なし、1:有り）
        Dim i As Integer
        Dim xydraw(ncount - 1) As Point
        Dim myBrush As New SolidBrush(colorx)

        For i = 1 To ncount
            xydraw(i - 1).X = Xdraw(i)
            xydraw(i - 1).Y = Ydraw(i)
        Next i
        gr.FillPolygon(myBrush, xydraw)

        If kind > 0 Then
            gr.DrawPolygon(Pens.Black, xydraw)
        End If

    End Sub

    Sub PerspecCalc(ByVal k1 As Integer, ByVal k2 As Integer, ByVal rlenscreen As Single, _
    ByRef xvbuf() As Single, ByRef yvbuf() As Single, ByRef zvbuf() As Single, _
    ByRef xsbuf() As Single, ByRef ysbuf() As Single)
        'ｽｸﾘｰﾝへの透視座標の計算
        'k1,k2･･･要素の開始、終了番号
        'rlenscreen･･･透視座標原点からｽｸﾘｰﾝまでの距離
        'xvbuf(),yvbuf(),zvbuf()･･･視線座標のX,Y,Z
        'xsbuf(),ysbuf()･･･ｽｸﾘｰﾝ座標のX,Y
        Dim ib, ie, j, nmax As Integer
        Dim b1 As Single
        Dim kbuf(Npoint) As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For j = 1 To nmax
                    ib = NNelem(ie, j)
                    If kbuf(ib) = 0 Then
                        b1 = rlenscreen / zvbuf(ib)
                        xsbuf(ib) = b1 * xvbuf(ib)
                        ysbuf(ib) = b1 * (yvbuf(ib) - Eyeh)
                        kbuf(ib) = 1
                    End If
                Next j
            End If
        Next ie

    End Sub

    Sub PlaneCutElem()
        '面切断の要素選択
        Dim ic, ie, j, k, nmax As Integer
        Dim b1, std As Single

        If KindElem = 0 Then
            nmax = 20
        End If
        If KE3DCut(2) > 0 Then
            std = VE3DCut(1) - VE3DCut(2)
        Else
            std = VE3DCut(1) + VE3DCut(2)
        End If

        For ie = 1 To Nelem
            If KdrawElem(ie) > 0 Then
                ic = 0
                For j = 1 To nmax
                    k = NNelem(ie, j)
                    Select Case KE3DCut(1)
                        Case 1
                            b1 = Xdata(k)
                        Case 2
                            b1 = Ydata(k)
                        Case 3
                            b1 = Zdata(k)
                    End Select
                    If KE3DCut(2) > 0 Then
                        If b1 < std Then
                            ic = 1
                        End If
                    Else
                        If b1 > std Then
                            ic = 1
                        End If
                    End If
                    If ic > 0 Then
                        KdrawElem(ie) = 0
                        Exit For
                    End If
                Next j
            End If
        Next ie

    End Sub

    Sub RotateCalc(ByVal kind As Integer, ByRef theta As Single)
        '回転角の計算
        'kind･･･象限番号
        'theta･･･回転角（左ねじ正、°）
        Dim ix, iy, kb As Integer
        Dim b1 As Single

        ix = Xmouse(2) - Xmouse(1)
        iy = Ymouse(2) - Ymouse(1)
        Select Case kind
            Case 1
                If ix > 0 Then
                    If iy >= 0 Then
                        kb = -1
                    Else
                        kind = 0
                    End If
                Else
                    If iy >= 0 Then
                        kind = 0
                    Else
                        kb = 1
                    End If
                End If
            Case 2
                If ix > 0 Then
                    If iy >= 0 Then
                        kind = 0
                    Else
                        kb = -1
                    End If
                Else
                    If iy >= 0 Then
                        kb = 1
                    Else
                        kind = 0
                    End If
                End If
            Case 3
                If ix > 0 Then
                    If iy >= 0 Then
                        kb = 1
                    Else
                        kind = 0
                    End If
                Else
                    If iy >= 0 Then
                        kind = 0
                    Else
                        kb = -1
                    End If
                End If
            Case 4
                If ix > 0 Then
                    If iy >= 0 Then
                        kind = 0
                    Else
                        kb = 1
                    End If
                Else
                    If iy >= 0 Then
                        kb = -1
                    Else
                        kind = 0
                    End If
                End If
        End Select
        b1 = Math.Sqrt(ix * ix + iy * iy)
        theta = kb * 3.0 * b1 / 50.0

    End Sub

    Sub ShapeFuncS(ByVal s As Single, ByVal t As Single, _
        ByVal u As Single)
        '形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        'u･･･要素のζ座標
        Dim s1, s1m, s2m, t1, t1m, t2m, u1, u1m, u2m As Single
        s1 = 1 + s
        s1m = 1 - s
        s2m = 1 - s * s
        t1 = 1 + t
        t1m = 1 - t
        t2m = 1 - t * t
        u1 = 1 + u
        u1m = 1 - u
        u2m = 1 - u * u
        Shape(1) = s1m * t1m * u1 * (-s - t + u - 2) / 8
        Shape(2) = s2m * t1m * u1 / 4
        Shape(3) = s1 * t1m * u1 * (s - t + u - 2) / 8
        Shape(4) = s1 * t2m * u1 / 4
        Shape(5) = s1 * t1 * u1 * (s + t + u - 2) / 8
        Shape(6) = s2m * t1 * u1 / 4
        Shape(7) = s1m * t1 * u1 * (-s + t + u - 2) / 8
        Shape(8) = s1m * t2m * u1 / 4
        Shape(9) = s1m * t1m * u2m / 4
        Shape(10) = s1 * t1m * u2m / 4
        Shape(11) = s1 * t1 * u2m / 4
        Shape(12) = s1m * t1 * u2m / 4
        Shape(13) = s1m * t1m * u1m * (-s - t - u - 2) / 8
        Shape(14) = s2m * t1m * u1m / 4
        Shape(15) = s1 * t1m * u1m * (s - t - u - 2) / 8
        Shape(16) = s1 * t2m * u1m / 4
        Shape(17) = s1 * t1 * u1m * (s + t - u - 2) / 8
        Shape(18) = s2m * t1 * u1m / 4
        Shape(19) = s1m * t1 * u1m * (-s + t - u - 2) / 8
        Shape(20) = s1m * t2m * u1m / 4

    End Sub

    Sub SurfaceCond(ByVal kb As Integer, ByRef kind As Integer, _
        ByRef kbuf() As Integer, ByRef gpos() As Double)
        '境界条件用の面設定
        'kb･･･面番号
        'kind･･･面分類（1:面1と2、2:面3と4、3:面5と6）
        'kbuf()･･･面節点の基本番号
        'gpos()･･･積分点のξηζ座標
        Dim i As Integer
        Select Case kb
            Case 1
                kind = 1
                gpos(3) = 1
                For i = 1 To 8
                    kbuf(i) = i
                Next i
            Case 2
                kind = 1
                gpos(3) = -1
                kbuf(1) = 13
                kbuf(2) = 20
                kbuf(3) = 19
                kbuf(4) = 18
                kbuf(5) = 17
                kbuf(6) = 16
                kbuf(7) = 15
                kbuf(8) = 14
            Case 3
                kind = 2
                gpos(2) = -1
                kbuf(1) = 1
                kbuf(2) = 9
                kbuf(3) = 13
                kbuf(4) = 14
                kbuf(5) = 15
                kbuf(6) = 10
                kbuf(7) = 3
                kbuf(8) = 2
            Case 4
                kind = 2
                gpos(2) = 1
                kbuf(1) = 5
                kbuf(2) = 11
                kbuf(3) = 17
                kbuf(4) = 18
                kbuf(5) = 19
                kbuf(6) = 12
                kbuf(7) = 7
                kbuf(8) = 6
            Case 5
                kind = 3
                gpos(1) = 1
                kbuf(1) = 3
                kbuf(2) = 10
                kbuf(3) = 15
                kbuf(4) = 16
                kbuf(5) = 17
                kbuf(6) = 11
                kbuf(7) = 5
                kbuf(8) = 4
            Case 6
                kind = 3
                gpos(1) = -1
                kbuf(1) = 7
                kbuf(2) = 12
                kbuf(3) = 19
                kbuf(4) = 20
                kbuf(5) = 13
                kbuf(6) = 9
                kbuf(7) = 1
                kbuf(8) = 8
        End Select

    End Sub

    Sub SurfaceDraw(ByRef gr As Graphics, ByVal k1 As Integer, _
    ByVal k2 As Integer, ByVal kind As Integer)
        '面の作画
        'k1,k2･･･要素の開始・終了番号
        'kind･･･面外周の作画有無（0:なし、1:有り）
        Dim aa$
        Dim ie, iex, j, jmax, k, kb, kbx, kk, kmax, nb, nb2, nmax As Integer
        Dim xb, xd, xi, xj, yb, yd, yi, yj As Single
        Dim fnt As Font = New Font("ＭＳ ゴシック", KnumSize)
        Dim fnt2 As Font = New Font("ＭＳ ゴシック", KnumSb, FontStyle.Bold)
        Dim kdisp(3) As Integer

        If KindElem = 0 Then
            jmax = 6
            kmax = 8
            nmax = 20
        End If
        If KrearTreat > 0 Then  '隠面処理有りの場合
            If KdispENum > 0 Then
                kdisp(1) = 1
            Else
                kdisp(1) = 0
            End If
            If KdispPNum > 0 Then
                kdisp(2) = 1
            Else
                kdisp(2) = 0
            End If
            If KdispSNum > 0 Then
                kdisp(3) = 1
            Else
                kdisp(3) = 0
            End If
            If KmouseElem > 0 Then
                nb2 = NSdraw + 1
            Else
                nb2 = NSdraw
            End If
            For nb = 1 To nb2
                If nb <= NSdraw Then
                    ie = KEorder(nb)
                    kb = KSorder(nb)
                    If ie = KmouseElem And kb = KmouseSurf Then
                        iex = ie
                        kbx = kb
                    End If
                Else
                    If iex = 0 Then
                        Exit For
                    End If
                    ie = iex
                    kb = kbx
                    kdisp(1) = 1
                    kdisp(2) = 1
                    kdisp(3) = 1
                End If
                If KindElem = 0 Then
                    Call SurfaceSet(ie, kb, KsurfPoint) '面の設定
                End If
                For k = 1 To kmax
                    kk = KsurfPoint(k)
                    xd = Xscreen(kk)
                    yd = Yscreen(kk)
                    Call XYCalc(xd, yd)     'X,Yの作画座標計算
                    Xdraw(k) = xd
                    Ydraw(k) = yd
                Next k
                If nb <= NSdraw Then
                    Call PaintExe(gr, kmax, Color.White, kind)
                End If
                If KnumDisp > 0 Then
                    xb = 0 : yb = 0
                    For k = 1 To kmax
                        xb = xb + Xdraw(k)
                        yb = yb + Ydraw(k)
                        If kdisp(2) > 0 Then
                            kk = KsurfPoint(k)
                            xd = Xdraw(k)
                            yd = Ydraw(k)
                            aa$ = LTrim$(Str$(kk))
                            gr.DrawString(aa$, fnt, Brushes.Black, xd, yd)
                        End If
                    Next k
                    If kdisp(3) > 0 Then
                        xd = xb / kmax
                        yd = yb / kmax
                        aa$ = "(" + LTrim$(Str$(kb)) + ")"
                        gr.DrawString(aa$, fnt, Brushes.Black, xd, yd)
                    End If
                    If kdisp(1) > 0 Then
                        xb = 0 : yb = 0
                        For j = 1 To nmax
                            kb = NNelem(ie, j)
                            xd = Xscreen(kb)
                            yd = Yscreen(kb)
                            Call XYCalc(xd, yd) 'X,Yの作画座標計算
                            xb = xb + xd
                            yb = yb + yd
                        Next j
                        xd = xb / nmax
                        yd = yb / nmax
                        aa$ = LTrim$(Str$(ie))
                        gr.DrawString(aa$, fnt2, Brushes.Black, xd, yd)
                    End If
                End If
            Next nb
        Else
            For ie = k1 To k2
                If KdrawElem(ie) > 0 Then
                    For j = 1 To jmax
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, j, KsurfPoint)  '面の設定
                        End If
                        kk = KsurfPoint(kmax)
                        xi = Xscreen(kk)
                        yi = Yscreen(kk)
                        Call XYCalc(xi, yi) 'X,Yの作画座標計算
                        xb = 0 : yb = 0
                        For k = 1 To kmax
                            kk = KsurfPoint(k)
                            xj = Xscreen(kk)
                            yj = Yscreen(kk)
                            Call XYCalc(xj, yj) 'X,Yの作画座標計算
                            xb = xb + xj
                            yb = yb + yj
                            gr.DrawLine(Pens.Black, xi, yi, xj, yj)
                            xi = xj
                            yi = yj
                        Next k
                        If KnumDisp > 0 And KdispSNum > 0 Then
                            xj = xb / kmax
                            yj = yb / kmax
                            aa$ = "(" + LTrim$(Str$(j)) + ")"
                            gr.DrawString(aa$, fnt, Brushes.Black, xj, yj)
                        End If
                    Next j
                End If
            Next ie
            If KnumDisp > 0 Then
                For ie = k1 To k2
                    If KdrawElem(ie) > 0 Then
                        xb = 0 : yb = 0
                        For j = 1 To nmax
                            kb = NNelem(ie, j)
                            xi = Xscreen(kb)
                            yi = Yscreen(kb)
                            Call XYCalc(xi, yi) 'X,Yの作画座標計算
                            If KdispPNum > 0 Then
                                aa$ = LTrim$(Str$(kb))
                                gr.DrawString(aa$, fnt, Brushes.Black, xi, yi)
                            End If
                            xb = xb + xi
                            yb = yb + yi
                        Next j
                        If KdispENum > 0 Then
                            xj = xb / nmax
                            yj = yb / nmax
                            aa$ = LTrim$(Str$(ie))
                            gr.DrawString(aa$, fnt2, Brushes.Black, xj, yj)
                        End If
                    End If
                Next ie
            End If
        End If

    End Sub

    Sub SurfaceSet(ByVal ib As Integer, ByVal kb As Integer, _
       ByRef kbuf() As Integer)
        '面の設定
        'ib･･･要素番号
        'kb･･･面番号
        'kbuf()･･･面の節点番号
        Select Case kb
            Case 1
                kbuf(1) = NNelem(ib, 1)
                kbuf(2) = NNelem(ib, 2)
                kbuf(3) = NNelem(ib, 3)
                kbuf(4) = NNelem(ib, 4)
                kbuf(5) = NNelem(ib, 5)
                kbuf(6) = NNelem(ib, 6)
                kbuf(7) = NNelem(ib, 7)
                kbuf(8) = NNelem(ib, 8)
            Case 2
                kbuf(1) = NNelem(ib, 13)
                kbuf(2) = NNelem(ib, 20)
                kbuf(3) = NNelem(ib, 19)
                kbuf(4) = NNelem(ib, 18)
                kbuf(5) = NNelem(ib, 17)
                kbuf(6) = NNelem(ib, 16)
                kbuf(7) = NNelem(ib, 15)
                kbuf(8) = NNelem(ib, 14)
            Case 3
                kbuf(1) = NNelem(ib, 1)
                kbuf(2) = NNelem(ib, 9)
                kbuf(3) = NNelem(ib, 13)
                kbuf(4) = NNelem(ib, 14)
                kbuf(5) = NNelem(ib, 15)
                kbuf(6) = NNelem(ib, 10)
                kbuf(7) = NNelem(ib, 3)
                kbuf(8) = NNelem(ib, 2)
            Case 4
                kbuf(1) = NNelem(ib, 5)
                kbuf(2) = NNelem(ib, 11)
                kbuf(3) = NNelem(ib, 17)
                kbuf(4) = NNelem(ib, 18)
                kbuf(5) = NNelem(ib, 19)
                kbuf(6) = NNelem(ib, 12)
                kbuf(7) = NNelem(ib, 7)
                kbuf(8) = NNelem(ib, 6)
            Case 5
                kbuf(1) = NNelem(ib, 3)
                kbuf(2) = NNelem(ib, 10)
                kbuf(3) = NNelem(ib, 15)
                kbuf(4) = NNelem(ib, 16)
                kbuf(5) = NNelem(ib, 17)
                kbuf(6) = NNelem(ib, 11)
                kbuf(7) = NNelem(ib, 5)
                kbuf(8) = NNelem(ib, 4)
            Case 6
                kbuf(1) = NNelem(ib, 7)
                kbuf(2) = NNelem(ib, 12)
                kbuf(3) = NNelem(ib, 19)
                kbuf(4) = NNelem(ib, 20)
                kbuf(5) = NNelem(ib, 13)
                kbuf(6) = NNelem(ib, 9)
                kbuf(7) = NNelem(ib, 1)
                kbuf(8) = NNelem(ib, 8)
        End Select

    End Sub

    Sub SurfSort(ByVal k1 As Integer, ByVal k2 As Integer)
        '作画面のｿｰﾃｨﾝｸﾞ
        'k1,k2･･･開始・終了要素番号
        Dim i1, i2, ic, ie, ii, ik1, ik2, j, k, kmax, nmax, nb As Integer
        Dim kbuf(8) As Integer

        If KindElem = 0 Then
            kmax = 6
            nmax = 8
        End If
        NSdraw = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For k = 1 To kmax
                    If KSelem(ie, k) = 0 Then
                        NSdraw = NSdraw + 1
                    End If
                Next k
            End If
        Next ie
        ReDim KEorder(NSdraw), KSorder(NSdraw)
        nb = 0
        For ie = k1 To k2
            If KdrawElem(ie) > 0 Then
                For k = 1 To kmax
                    If KSelem(ie, k) = 0 Then
                        nb = nb + 1
                        KEorder(nb) = ie
                        KSorder(nb) = k
                    End If
                Next k
            End If
        Next ie

        For ii = 1 To NSdraw - 1
            i1 = KEorder(ii)
            ik1 = KSorder(ii)
            If KindElem = 0 Then
                Call SurfaceSet(i1, ik1, KsurfPoint)    '面の設定
            End If

            For j = ii + 1 To NSdraw
                i2 = KEorder(j)
                ik2 = KSorder(j)
                If KindElem = 0 Then
                    Call SurfaceSet(i2, ik2, kbuf)      '面の設定
                End If

                Call DistComp(ic, kbuf)    '距離比較
                If ic = 0 Then
                    KEorder(ii) = i2
                    KSorder(ii) = ik2
                    KEorder(j) = i1
                    KSorder(j) = ik1
                    i1 = i2
                    ik1 = ik2
                    For k = 1 To nmax
                        KsurfPoint(k) = kbuf(k)
                    Next k
                End If
            Next j
        Next ii

    End Sub

    Sub TmatMulti(ByRef tr1buf(,) As Single, ByRef tr2buf(,) As Single)
        '変換行列の掛算
        'tr1buf(,)･･･最初の変換行列
        'tr2buf(,)･･･次の変換行列および結果の変化行列
        Dim i, j, k As Integer
        Dim b1 As Single
        Dim buf(4, 4) As Single

        For i = 1 To 4
            For j = 1 To 4
                buf(i, j) = tr2buf(i, j)
            Next j
        Next i
        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + buf(i, k) * tr1buf(k, j)
                Next k
                tr2buf(i, j) = b1
            Next j
        Next i

    End Sub

    Sub TmatrixCalD(ByVal xr As Single, ByVal yr As Single, ByVal zr As Single, _
    ByRef trbuf(,) As Single)
        'ﾓﾃﾞﾙの合成ｱﾌｨﾝ変換行列算出
        'Z,Y,X軸回りの回転
        'xr,yr,zr･･･X,Y,Z軸回りの回転角（右ねじ正、°）
        'trbuf(,)･･･変換ﾏﾄﾘｯｸｽ
        Dim i, j, k As Integer
        Dim b1, b2, thetax, thetay, thetaz As Single
        Dim buf1(4, 4), buf2(4, 4), buf3(4, 4), buf4(4, 4) As Single

        b1 = Pai / 180
        thetax = xr * b1
        thetay = yr * b1
        thetaz = zr * b1

        For i = 1 To 4
            buf1(i, i) = 1
        Next i

        b1 = Math.Cos(thetax)
        b2 = Math.Sin(thetax)
        buf2(1, 1) = 1
        buf2(2, 2) = b1
        buf2(2, 3) = -b2
        buf2(3, 2) = b2
        buf2(3, 3) = b1
        buf2(4, 4) = 1

        b1 = Math.Cos(thetay)
        b2 = Math.Sin(thetay)
        buf3(1, 1) = b1
        buf3(1, 3) = b2
        buf3(2, 2) = 1
        buf3(3, 1) = -b2
        buf3(3, 3) = b1
        buf3(4, 4) = 1

        b1 = Math.Cos(thetaz)
        b2 = Math.Sin(thetaz)
        buf4(1, 1) = b1
        buf4(1, 2) = -b2
        buf4(2, 1) = b2
        buf4(2, 2) = b1
        buf4(3, 3) = 1
        buf4(4, 4) = 1

        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + buf1(i, k) * buf2(k, j)
                Next k
                trbuf(i, j) = b1
            Next j
        Next i
        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + trbuf(i, k) * buf3(k, j)
                Next k
                buf1(i, j) = b1
            Next j
        Next i
        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + buf1(i, k) * buf4(k, j)
                Next k
                trbuf(i, j) = b1
            Next j
        Next i

    End Sub

    Sub TmatrixCalE(ByVal xr As Single, ByVal yr As Single, ByVal zr As Single, _
    ByRef trbuf(,) As Single)
        '座標軸の合成ｱﾌｨﾝ変換行列算出
        'Z,Y,X軸回りの回転
        'xr,yr,zr･･･X,Y,Z軸回りの回転角（右ねじ正、°）
        'trbuf(,)･･･変換ﾏﾄﾘｯｸｽ
        Dim i, j, k As Integer
        Dim b1, b2, thetax, thetay, thetaz As Single
        Dim buf1(4, 4), buf2(4, 4), buf3(4, 4), buf4(4, 4) As Single

        b1 = Pai / 180
        thetax = xr * b1
        thetay = yr * b1
        thetaz = zr * b1

        For i = 1 To 4
            buf1(i, i) = 1
        Next i

        b1 = Math.Cos(thetax)
        b2 = Math.Sin(thetax)
        buf2(1, 1) = 1
        buf2(2, 2) = b1
        buf2(2, 3) = b2
        buf2(3, 2) = -b2
        buf2(3, 3) = b1
        buf2(4, 4) = 1

        b1 = Math.Cos(thetay)
        b2 = Math.Sin(thetay)
        buf3(1, 1) = b1
        buf3(1, 3) = -b2
        buf3(2, 2) = 1
        buf3(3, 1) = b2
        buf3(3, 3) = b1
        buf3(4, 4) = 1

        b1 = Math.Cos(thetaz)
        b2 = Math.Sin(thetaz)
        buf4(1, 1) = b1
        buf4(1, 2) = b2
        buf4(2, 1) = -b2
        buf4(2, 2) = b1
        buf4(3, 3) = 1
        buf4(4, 4) = 1

        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + buf1(i, k) * buf2(k, j)
                Next k
                trbuf(i, j) = b1
            Next j
        Next i
        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + trbuf(i, k) * buf3(k, j)
                Next k
                buf1(i, j) = b1
            Next j
        Next i
        For i = 1 To 4
            For j = 1 To 4
                b1 = 0
                For k = 1 To 4
                    b1 = b1 + buf1(i, k) * buf4(k, j)
                Next k
                trbuf(i, j) = b1
            Next j
        Next i

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Flow3DLine.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fstruct$ = sr.ReadLine
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Flow3DLine.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fstruct$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\FL3LUFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\FL3LUFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub XYCalc(ByRef xb As Single, ByRef yb As Single)
        'X,Yの作画座標計算
        'xb･･･X座標値
        'yb･･･Y座標値
        Dim b1, b2 As Single
        b1 = xb - XaxisMin
        b2 = yb - YaxisMin
        If Cfix < 1 Then
            xb = b1 * XYscale + Xlower
            yb = Yupper - b2 * XYscale * Cfix
        Else
            xb = b1 * XYscale / Cfix + Xlower
            yb = Yupper - b2 * XYscale
        End If
    End Sub

End Module
